#pragma once

#include <unknwn.h>
#include "arrays.h"

#define NEED_DIALOG_ACCELERATORS

#define ON_MSG( msg ) case msg: return ON_##msg( wParam, lParam )

typedef SPI<IUnknown> SPIUnknown;

class DlgBase
{
public:
					DlgBase();
	virtual			~DlgBase();

	INT_PTR			DoModal( HWND hwndParent, UINT idDlg, UINT idrAccel = 0 );

	BOOL			EndDialog( INT_PTR nResult );
	LRESULT			SendMessage( UINT msg, WPARAM wParam, LPARAM lParam );
	LRESULT			SendDlgItemMessage( UINT idc, UINT msg, WPARAM wParam, LPARAM lParam );
	HWND			GetDlgItem( UINT idc );
	void			SetDlgItemFocus( UINT idc, bool fNext = true );
	BOOL			DisableControl( UINT idc, UINT idcMaybeNewFocus = 0, UINT idcMaybeNewDefault = 0 );
	BOOL			EnableControl( UINT idc );
	void			EnableControl( UINT idc, bool fEnable );
	void			InitRichEdit( UINT idc, unsigned cchLimit = 0, DWORD dwEnmMask = 0 );
	bool			HandleEditCommand( HWND hwndControl, UINT idm );

protected:
	virtual INT_PTR	DlgProc( UINT msg, WPARAM wParam, LPARAM lParam ) = 0;

protected:
	UINT			m_idDlg;
	HWND			m_hwnd;
	Rg<SPIUnknown>	m_rgReleaseOnClose;

#ifdef NEED_DIALOG_ACCELERATORS
	HACCEL			m_haccel;
	bool			m_fContinueModal;
	int				m_nResult;
#endif

	static INT_PTR CALLBACK StaticDlgProc( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam );
};

